#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, m;
    cin >> n >> m;
    vector<vector<int>> kompleks(n, vector<int>(m));
    long long suma_kompleksa = 0;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> kompleks[i][j];
            suma_kompleksa += kompleks[i][j];
        }
    }

    // za N = 2 (10 poena).

    vector<vector<int>> dp(n, vector<int>(m));
    dp[0][0] = kompleks[0][0];
    dp[1][0] = dp[0][0] + kompleks[1][0];

    for (int i = 1; i < m; i++) {
        dp[0][i] = dp[0][i-1] + kompleks[0][i];
    }
    for (int j = 1; j < m; j++) {
        dp[1][j] = max(dp[1][j-1], dp[0][j]) + kompleks[1][j];
    }

    cout << suma_kompleksa - dp[1][m - 1] << endl;
    return 0;
}